/* eslint no-console:off */
module.exports = function (cfg, webpackCfg) {
    const
        ora = require("ora"),
        rm = require("rimraf"),
        path = require("path"),
        chalk = require("chalk"),
        webpack = require("webpack"),

        spinner = ora("building for production...");
    spinner.start();

    rm(path.join(cfg.build.assetsRoot, cfg.build.assetsSubDirectory), err => {
        if (err) {
            throw err;
        }
        webpack(webpackCfg, function (err, stats) {
            spinner.stop();
            if (err) {
                throw err;
            }
            process.stdout.write(stats.toString({
                colors: true,
                modules: false,
                children: false,
                chunks: false,
                chunkModules: false
            }) + "\n\n");

            if (stats.hasErrors()) {
                console.log(chalk.red("  Build failed with errors.\n"));
                process.exit(1);
            }

            console.log(chalk.cyan("  Build complete.\n"));
            console.log(chalk.yellow(
                "  Tip: built files are meant to be served over an HTTP server.\n" +
                "  Opening index.html over file:// won't work.\n"
            ));
        });
    });
};
