// see http://vuejs-templates.github.io/webpack for documentation.

const merge = require("webpack-merge"),
    devserverCfg = require("gs-devserver/config/index");

module.exports = merge({
    build: {
        env: require("./prod.env"),
        // @type {object|array} webpack entry configuration
        entry: {
            app: "./src/main.js"
        },
        // redefine to static dir
        // NOTE change index|assetsRoot|assetsPublicPath as necessary
        // HtmlWebpackPlugin output filename, absolute path
        index: "",
        // HtmlWebpackPlugin template file
        template: "!!raw-loader!index.html",
        // webpack output path
        assetsRoot: "",
        assetsSubDirectory: "",
        // webpack  output publicPath
        assetsPublicPath: "",
        staticDir: "./static",
        productionSourceMap: false,
        // Gzip off by default as many popular static hosts such as
        // Surge or Netlify already gzip all static assets for you.
        // Before setting to `true`, make sure to:
        // npm install --save-dev compression-webpack-plugin
        productionGzip: false,
        productionGzipExtensions: ["js", "css"],
        // Run the build command with an extra argument to
        // View the bundle analyzer report after build finishes:
        // `npm run build --report`
        // Set to `true` or `false` to always turn it on or off
        bundleAnalyzerReport: process.env.npm_config_report,
        // @type {object} html-webpack-plugin configuration interface
        htmlwebpackplugin: undefined,
        // @type {array} babel loader plugins
        babelLoaderPlugins: null,
        // @type {object|array} webpack extra plugins
        plugins: null
    },
    dev: {}
}, devserverCfg, {
    dev: {
        env: require("./dev.env"),
        entry: {
            app: "./src/main.js"
        },
        index: "index.html",
        template: "!!raw-loader!index.html",
        assetsRoot: "",
        // CSS Sourcemaps off by default because relative paths are "buggy"
        // with this option, according to the CSS-Loader README
        // (https://github.com/webpack/css-loader#sourcemaps)
        // In our experience, they generally work as expected,
        // just be aware of this issue when enabling this option.
        cssSourceMap: false,
        historyApiOptions: {
            // https://www.npmjs.com/package/connect-history-api-fallback#options
        },
        bundleAnalyzerReport: process.env.npm_config_report,
        htmlwebpackplugin: undefined,
        babelLoaderPlugins: null,
        plugins: null
    }
});