// https://www.sitemaps.org/protocol.html
// https://support.google.com/webmasters/answer/189077?hl=en
const
    fs = require("fs"),
    path = require("path"),
    _ = require("lodash"),
    logging = require("gs-common/fe/Logging"),
    URL_TEMPLATE = _.template(fs.readFileSync(path.join(__dirname, "url.template"), "utf-8")),
    SITEMAP_TEMPLATE = _.template(fs.readFileSync(path.join(__dirname, "sitemap.template"), "utf-8")),

    DOMAINS = ["sports.garmin.com"],
    PATH_NAMES = ["/"],
    ARTICLE_IDS = [];

JSON.parse(fs.readFileSync(path.join(__dirname, "articles.json"), "utf-8"))
    .page
    .forEach(article => {
        ARTICLE_IDS.push(article.articleId);
    });

ARTICLE_IDS.forEach(articleId => {
    const pathname = `/web/article/${articleId}`;
    PATH_NAMES.push(pathname);
});

DOMAINS.forEach(domain => {
    const urlXml = [];
    PATH_NAMES.forEach(pathname => {
        const
            url = `https://${domain}${pathname}`,
            xml = URL_TEMPLATE({
                url
            });
        logging.info("url xml");
        logging.info("\n" + xml);
        urlXml.push(xml);
    });

    const
        sitemap = SITEMAP_TEMPLATE({
            urlXml: urlXml.join("\n")
        }),
        sitemapFile = path.join(__dirname, "sitemap.xml");
    logging.info("====================================");
    logging.info("\n" + sitemap);
    logging.info("====================================");
    logging.info("write sitemap.xml to", sitemapFile);
    fs.writeFileSync(sitemapFile, sitemap, "utf-8");
});
