const utils = require("./utils");
let vueLoaderCfg;

module.exports = function (config) {
    if (!vueLoaderCfg) {
        utils.config(config);
        let isProduction = process.env.NODE_ENV === "production";
        vueLoaderCfg = {
            loaders: utils.cssLoaders({
                sourceMap: isProduction
                    ? config.build.productionSourceMap
                    : config.dev.cssSourceMap,
                extract: isProduction
            }),
            transformToRequire: {
                video: "src",
                source: "src",
                img: "src",
                image: "xlink:href"
            }
        };
    }
    return vueLoaderCfg;
};