module.exports = {
    pkg: {
        name: "",
        version: "0.1.0",
        description: "",
        author: "",
        localizer: false,
        localizerSourcePath: "../../../translation/src/main/resources/bundle",
        // localizer destination key, e.g. mobile/blog
        localizerDest: "",
        convert: (key, input) => {
            if (key === "localizer") {
                return input === "true";
            }
            return input;
        },
        question: (key) => {
            const msg = {
                localizer: "localizer, true or false for translation support, default: `false`",
                localizerSourcePath: "localizerSourcePath, default `../../../translation/src/main/resources/bundle`",
                localizerDest: "localizerDest, localizer destination key, e.g. mobile/blog"
            }[key] || key;
            return `package ${msg}\n`;
        },
        stop: (key, input) => {
            if (key === "localizer" && (input === false || !input)) {
                return true;
            }
            return key === "localizerDest";
        }
    },
    cfg: {
        // webpack public path, NOTE without tail slash
        // e.g. /content/static/act/competition-team
        basePath: "",
        question: (key) => {
            return `${key}, webpack public path, NOTE without tail slash\n` +
                "e.g. /content/static/act/competition-team\n";
        },
        stop: () => { return true; }
    },
    pack: {
        basePath: "",
        cwd: "",
        dir: ""
    },
    gsModules: {
        modulePath: "../../../../translation/gs-modules",
        question: (key) => {
            return `${key}, gs-modules path\n` +
                "e.g. ../../../../translation/gs-modules\n";
        },
        stop: () => { return true; }
    }
};