/*
 * @Author: Dylan
 * @Date: 2021-07-20 16:22:59
 * @LastEditors: Dylan
 * @LastEditTime: 2021-07-21 15:16:20
 * @Description: file content
 */
const fs = require("fs"),
    path = require("path"),
    loadingPath = "{{modulePath}}/src/vue/components/loading",
    copyExg = /\.(js|css)$/i;

copyFolder(loadingPath, "../static/static/loading", false);

/**
 * @des /**
 * @param { delPath：String } （需要删除文件的地址）
 * @param { direct：Boolean } （是否需要处理地址）
 */
function copyFolder (copiedPath, resultPath, direct) {
    if (!direct) {
        copiedPath = path.join(__dirname, copiedPath);
        resultPath = path.join(__dirname, resultPath);
    }

    if (fs.existsSync(copiedPath)) {

        if (fs.existsSync(resultPath)) {
            deleteFolder(resultPath);
        }

        mkdirs(resultPath);

        const files = fs.readdirSync(copiedPath, { withFileTypes: true });

        for (let i = 0; i < files.length; i++) {
            const cf = files[i];

            if (!copyExg.test(cf.name)) {
                continue;
            }

            const ccp = path.join(copiedPath, cf.name),
                crp = path.join(resultPath, cf.name);

            if (cf.isFile()) {
                /**
                     * @des 创建文件,使用流的形式可以读写大文件
                     */
                const readStream = fs.createReadStream(ccp),
                    writeStream = fs.createWriteStream(crp);
                readStream.pipe(writeStream);
            } else {
                try {
                    /**
                         * @des 判断读(R_OK | W_OK)写权限
                         */
                    fs.accessSync(path.join(crp, ".."), fs.constants.W_OK);
                    copyFolder(ccp, crp, true);
                } catch (error) {
                    console.log("folder write error:", error);
                }

            }
        }
        // eslint-disable-next-line no-console
        console.log("=== copy success  ===");
    } else {
        // eslint-disable-next-line no-console
        console.log("do not exist path: ", copiedPath);
    }
}

function mkdirs (dirpath) {
    if (!fs.existsSync(path.dirname(dirpath))) {
        mkdirs(path.dirname(dirpath));
    }
    fs.mkdirSync(dirpath);
}


function deleteFolder (path) {
    let files = [];
    if (fs.existsSync(path)) {
        files = fs.readdirSync(path);
        files.forEach(function (file) {
            let curPath = path + "/" + file;
            if (fs.statSync(curPath).isDirectory()) {
                deleteFolder(curPath);
            } else {
                fs.unlinkSync(curPath);
            }
        });
        fs.rmdirSync(path);
    }
}
