// base JS language extension
import "gs-common/dist/fe/Lang";
// axios depends on Promise, IE not support Promise natively
import "promise-polyfill/src/polyfill";
import logging from "gs-common/dist/fe/Logging";
logging.enabled(true);

export default {
    name: "app",
    components: {},
    data: function () {
        return {
            name: "hello world!"
        };
    },
    mounted () {
        // if has router-view can use this
        // <router-view @hook:mounted='removeLoad'></router-view>
        // listener router hook mounted
        this.removeLoad();
    },
    methods: {
        removeLoad () {
            let loadingWrap = document.getElementById("loading-wrap");
            if (loadingWrap) {
                loadingWrap.remove();
            }
        }
    },
    errorCaptured: function (err, vm, info) {
        logging.error(err, vm, JSON.stringify(info));
    }
};