// see http://vuejs-templates.github.io/webpack for documentation.
let
    merge = require("webpack-merge"),
    defaultCfg = require("../../config"),
    config;

module.exports = function (cfg) {
    config = merge({}, defaultCfg, {
        dev: {
            open: true,
            auth: true
        }
    }, cfg);

    const contentProxy = config.dev.proxyTable["/content/**"];
    if (contentProxy) {
        // override /content/** path default proxy handler
        // exclude path /content/static/**
        config.dev.proxyTable["/content/**"] = {
            // vue pages use /content/static/** path
            filter: function (pathname) {
                return /^\/content\//.test(pathname) &&
                    !/^\/content\/static\//.test(pathname);
            },
            target: contentProxy,
            secure: false
        };
    }

    return config;
};